/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 24 "../../smtpd/parse.y"

#include "includes.h"

#include <sys/types.h>
#include <sys/time.h>
#include <sys/queue.h>
#include <sys/tree.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/ioctl.h>

#include <net/if.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <ctype.h>
#include <err.h>
#include <errno.h>
#include <event.h>
#include <ifaddrs.h>
#include <imsg.h>
#include <inttypes.h>
#include <limits.h>
#include <netdb.h>
#include <paths.h>
#include <pwd.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <unistd.h>
#ifdef HAVE_UTIL_H
#include <util.h>
#endif

#include <openssl/ssl.h>

#include "smtpd.h"
#include "ssl.h"
#include "log.h"

TAILQ_HEAD(files, file)		 files = TAILQ_HEAD_INITIALIZER(files);
static struct file {
	TAILQ_ENTRY(file)	 entry;
	FILE			*stream;
	char			*name;
	int			 lineno;
	int			 errors;
} *file, *topfile;
struct file	*pushfile(const char *, int);
int		 popfile(void);
int		 check_file_secrecy(int, const char *);
int		 yyparse(void);
int		 yylex(void);
int		 kw_cmp(const void *, const void *);
int		 lookup(char *);
int		 lgetc(int);
int		 lungetc(int);
int		 findeol(void);
int		 yyerror(const char *, ...)
    __attribute__((__format__ (printf, 1, 2)))
    __attribute__((__nonnull__ (1)));

TAILQ_HEAD(symhead, sym)	 symhead = TAILQ_HEAD_INITIALIZER(symhead);
struct sym {
	TAILQ_ENTRY(sym)	 entry;
	int			 used;
	int			 persist;
	char			*nam;
	char			*val;
};
int		 symset(const char *, const char *, int);
char		*symget(const char *);

struct smtpd		*conf = NULL;
static int		 errors = 0;

struct filter_conf	*filter = NULL;
struct table		*table = NULL;
struct rule		*rule = NULL;
struct listener		 l;
struct mta_limits	*limits;
static struct pki	*pki;

enum listen_options {
	LO_FAMILY	= 0x01,
	LO_PORT		= 0x02,
	LO_SSL		= 0x04,
	LO_FILTER      	= 0x08,
	LO_PKI      	= 0x10,
	LO_AUTH      	= 0x20,
	LO_TAG      	= 0x40,
	LO_HOSTNAME   	= 0x80,
	LO_HOSTNAMES   	= 0x100,
	LO_MASKSOURCE  	= 0x200,
	LO_NODSN	= 0x400,
};

static struct listen_opts {
	char	       *ifx;
	int		family;
	in_port_t	port;
	uint16_t	ssl;
	char	       *filtername;
	char	       *pki;
	uint16_t       	auth;
	struct table   *authtable;
	char	       *tag;
	char	       *hostname;
	struct table   *hostnametable;
	uint16_t	flags;

	uint16_t       	options;
} listen_opts;

static void	create_listener(struct listenerlist *,  struct listen_opts *);
static void	config_listener(struct listener *,  struct listen_opts *);

struct listener	*host_v4(const char *, in_port_t);
struct listener	*host_v6(const char *, in_port_t);
int		 host_dns(struct listenerlist *, struct listen_opts *);
int		 host(struct listenerlist *, struct listen_opts *);
int		 interface(struct listenerlist *, struct listen_opts *);
void		 set_local(const char *);
void		 set_localaddrs(struct table *);
int		 delaytonum(char *);
int		 is_if_in_group(const char *, const char *);

static struct filter_conf *create_filter_proc(char *, char *);
static struct filter_conf *create_filter_chain(char *);
static int add_filter_arg(struct filter_conf *, char *);

typedef struct {
	union {
		int64_t		 number;
		struct table	*table;
		char		*string;
		struct host	*host;
		struct mailaddr	*maddr;
	} v;
	int lineno;
} YYSTYPE;


/* Line 371 of yacc.c  */
#line 214 "parse.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     AS = 258,
     QUEUE = 259,
     COMPRESSION = 260,
     ENCRYPTION = 261,
     MAXMESSAGESIZE = 262,
     MAXMTADEFERRED = 263,
     LISTEN = 264,
     ON = 265,
     ANY = 266,
     PORT = 267,
     EXPIRE = 268,
     TABLE = 269,
     SECURE = 270,
     SMTPS = 271,
     CERTIFICATE = 272,
     DOMAIN = 273,
     BOUNCEWARN = 274,
     LIMIT = 275,
     INET4 = 276,
     INET6 = 277,
     NODSN = 278,
     RELAY = 279,
     BACKUP = 280,
     VIA = 281,
     DELIVER = 282,
     TO = 283,
     LMTP = 284,
     MAILDIR = 285,
     MBOX = 286,
     HOSTNAME = 287,
     HOSTNAMES = 288,
     ACCEPT = 289,
     REJECT = 290,
     INCLUDE = 291,
     ERROR = 292,
     MDA = 293,
     FROM = 294,
     FOR = 295,
     SOURCE = 296,
     MTA = 297,
     PKI = 298,
     SCHEDULER = 299,
     ARROW = 300,
     AUTH = 301,
     TLS = 302,
     LOCAL = 303,
     VIRTUAL = 304,
     TAG = 305,
     TAGGED = 306,
     ALIAS = 307,
     FILTER = 308,
     KEY = 309,
     CA = 310,
     DHPARAMS = 311,
     AUTH_OPTIONAL = 312,
     TLS_REQUIRE = 313,
     USERBASE = 314,
     SENDER = 315,
     MASK_SOURCE = 316,
     VERIFY = 317,
     FORWARDONLY = 318,
     RECIPIENT = 319,
     STRING = 320,
     NUMBER = 321
   };
#endif
/* Tokens.  */
#define AS 258
#define QUEUE 259
#define COMPRESSION 260
#define ENCRYPTION 261
#define MAXMESSAGESIZE 262
#define MAXMTADEFERRED 263
#define LISTEN 264
#define ON 265
#define ANY 266
#define PORT 267
#define EXPIRE 268
#define TABLE 269
#define SECURE 270
#define SMTPS 271
#define CERTIFICATE 272
#define DOMAIN 273
#define BOUNCEWARN 274
#define LIMIT 275
#define INET4 276
#define INET6 277
#define NODSN 278
#define RELAY 279
#define BACKUP 280
#define VIA 281
#define DELIVER 282
#define TO 283
#define LMTP 284
#define MAILDIR 285
#define MBOX 286
#define HOSTNAME 287
#define HOSTNAMES 288
#define ACCEPT 289
#define REJECT 290
#define INCLUDE 291
#define ERROR 292
#define MDA 293
#define FROM 294
#define FOR 295
#define SOURCE 296
#define MTA 297
#define PKI 298
#define SCHEDULER 299
#define ARROW 300
#define AUTH 301
#define TLS 302
#define LOCAL 303
#define VIRTUAL 304
#define TAG 305
#define TAGGED 306
#define ALIAS 307
#define FILTER 308
#define KEY 309
#define CA 310
#define DHPARAMS 311
#define AUTH_OPTIONAL 312
#define TLS_REQUIRE 313
#define USERBASE 314
#define SENDER 315
#define MASK_SOURCE 316
#define VERIFY 317
#define FORWARDONLY 318
#define RECIPIENT 319
#define STRING 320
#define NUMBER 321



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE yylval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 408 "parse.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   213

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  75
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  71
/* YYNRULES -- Number of rules.  */
#define YYNRULES  170
/* YYNRULES -- Number of states.  */
#define YYNSTATES  261

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   321

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      67,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    74,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    69,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      72,    68,    73,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    70,     2,    71,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     7,    11,    15,    19,    23,    27,
      31,    34,    38,    40,    42,    43,    46,    47,    50,    52,
      54,    58,    60,    64,    66,    67,    70,    73,    74,    76,
      78,    81,    84,    85,    88,    91,    92,    95,    98,   101,
     104,   107,   108,   110,   112,   115,   118,   121,   123,   126,
     128,   130,   132,   135,   138,   140,   142,   145,   148,   151,
     154,   157,   159,   161,   164,   165,   168,   171,   174,   177,
     180,   183,   185,   187,   190,   193,   196,   197,   200,   202,
     205,   208,   209,   210,   214,   217,   220,   225,   228,   231,
     234,   238,   239,   247,   248,   253,   257,   258,   264,   265,
     271,   272,   277,   278,   279,   283,   287,   288,   295,   297,
     299,   303,   305,   309,   311,   313,   317,   319,   321,   323,
     324,   329,   333,   335,   337,   340,   343,   345,   347,   350,
     354,   359,   363,   368,   373,   376,   377,   383,   385,   386,
     391,   395,   399,   404,   408,   412,   416,   420,   422,   425,
     427,   429,   431,   433,   435,   438,   439,   441,   443,   446,
     447,   449,   451,   452,   454,   456,   459,   460,   461,   468,
     469
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      76,     0,    -1,    -1,    76,    67,    -1,    76,    77,    67,
      -1,    76,    78,    67,    -1,    76,   101,    67,    -1,    76,
     110,    67,    -1,    76,   143,    67,    -1,    76,     1,    67,
      -1,    36,    65,    -1,    65,    68,    65,    -1,    69,    -1,
      81,    -1,    -1,    67,    80,    -1,    -1,    67,    80,    -1,
      66,    -1,    65,    -1,    51,   129,    65,    -1,    65,    -1,
      85,    69,    84,    -1,    84,    -1,    -1,    65,    66,    -1,
      86,    87,    -1,    -1,    21,    -1,    22,    -1,    65,    66,
      -1,    88,    89,    -1,    -1,    65,    66,    -1,    90,    91,
      -1,    -1,    17,    65,    -1,    54,    65,    -1,    55,    65,
      -1,    56,    65,    -1,    92,    93,    -1,    -1,    21,    -1,
      22,    -1,    12,    65,    -1,    12,    66,    -1,    53,    65,
      -1,    16,    -1,    16,    62,    -1,    47,    -1,    15,    -1,
      58,    -1,    58,    62,    -1,    43,    65,    -1,    46,    -1,
      57,    -1,    46,   121,    -1,    57,   121,    -1,    50,    65,
      -1,    32,    65,    -1,    33,   121,    -1,    61,    -1,    23,
      -1,    94,    95,    -1,    -1,     3,    65,    -1,    41,   121,
      -1,    32,    65,    -1,    33,   121,    -1,    43,    65,    -1,
      25,    65,    -1,    25,    -1,    47,    -1,    47,    62,    -1,
      96,    98,    -1,    97,    98,    -1,    -1,    46,   121,    -1,
      62,    -1,    96,   100,    -1,    99,   100,    -1,    -1,    -1,
      19,   102,    85,    -1,     4,     5,    -1,     4,     6,    -1,
       4,     6,    54,    65,    -1,    13,    65,    -1,     7,    82,
      -1,     8,    66,    -1,    20,    38,    87,    -1,    -1,    20,
      42,    40,    18,    65,   103,    89,    -1,    -1,    20,    42,
     104,    89,    -1,    20,    44,    91,    -1,    -1,     9,   105,
      10,    65,    95,    -1,    -1,    53,    65,    65,   106,   108,
      -1,    -1,    43,    65,   107,    93,    -1,    -1,    -1,    65,
     109,   108,    -1,    14,    65,    65,    -1,    -1,    14,    65,
     111,    70,   117,    71,    -1,    68,    -1,    45,    -1,    65,
     112,    65,    -1,   113,    -1,   113,    79,   114,    -1,    65,
      -1,   115,    -1,   115,    79,   116,    -1,   116,    -1,   114,
      -1,    65,    -1,    -1,    70,   119,   117,    71,    -1,    72,
      65,    73,    -1,   118,    -1,   120,    -1,    52,   121,    -1,
      49,   121,    -1,   122,    -1,   123,    -1,    59,   121,    -1,
      27,    28,    30,    -1,    27,    28,    30,    65,    -1,    27,
      28,    31,    -1,    27,    28,    29,    65,    -1,    27,    28,
      38,    65,    -1,    24,    98,    -1,    -1,    24,    26,    65,
     128,   100,    -1,    74,    -1,    -1,    39,   129,    41,   121,
      -1,    39,   129,    11,    -1,    39,   129,    48,    -1,    40,
     129,    18,   121,    -1,    40,   129,    11,    -1,    40,   129,
      48,    -1,    60,   129,   121,    -1,    64,   129,   121,    -1,
      63,    -1,    13,    65,    -1,   132,    -1,   133,    -1,   130,
      -1,   131,    -1,    83,    -1,   136,   137,    -1,    -1,   125,
      -1,   124,    -1,   138,   139,    -1,    -1,   126,    -1,   127,
      -1,    -1,   135,    -1,   134,    -1,   141,   142,    -1,    -1,
      -1,    34,   144,   137,   139,   140,   142,    -1,    -1,    35,
     145,   137,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   184,   184,   185,   186,   187,   188,   189,   190,   191,
     194,   209,   217,   218,   219,   222,   223,   226,   229,   236,
     249,   261,   280,   281,   282,   285,   310,   311,   314,   317,
     320,   330,   331,   334,   356,   357,   360,   363,   366,   369,
     374,   375,   378,   386,   394,   412,   425,   433,   441,   449,
     457,   465,   473,   481,   489,   497,   505,   514,   523,   537,
     546,   562,   570,   580,   581,   584,   609,   619,   624,   634,
     651,   662,   668,   671,   676,   677,   678,   681,   692,   701,
     702,   703,   706,   706,   709,   712,   715,   724,   733,   736,
     739,   740,   740,   752,   752,   755,   756,   756,   765,   765,
     781,   781,   794,   795,   795,   803,   840,   840,   848,   848,
     850,   858,   859,   862,   869,   870,   873,   874,   877,   886,
     886,   893,   906,   907,   910,   923,   935,   943,   953,   969,
     976,   984,   991,  1002,  1012,  1015,  1015,  1034,  1035,  1038,
    1053,  1061,  1071,  1086,  1094,  1104,  1122,  1140,  1149,  1164,
    1165,  1166,  1167,  1168,  1170,  1171,  1174,  1175,  1177,  1178,
    1181,  1182,  1183,  1186,  1187,  1190,  1191,  1194,  1194,  1226,
    1226
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "AS", "QUEUE", "COMPRESSION",
  "ENCRYPTION", "MAXMESSAGESIZE", "MAXMTADEFERRED", "LISTEN", "ON", "ANY",
  "PORT", "EXPIRE", "TABLE", "SECURE", "SMTPS", "CERTIFICATE", "DOMAIN",
  "BOUNCEWARN", "LIMIT", "INET4", "INET6", "NODSN", "RELAY", "BACKUP",
  "VIA", "DELIVER", "TO", "LMTP", "MAILDIR", "MBOX", "HOSTNAME",
  "HOSTNAMES", "ACCEPT", "REJECT", "INCLUDE", "ERROR", "MDA", "FROM",
  "FOR", "SOURCE", "MTA", "PKI", "SCHEDULER", "ARROW", "AUTH", "TLS",
  "LOCAL", "VIRTUAL", "TAG", "TAGGED", "ALIAS", "FILTER", "KEY", "CA",
  "DHPARAMS", "AUTH_OPTIONAL", "TLS_REQUIRE", "USERBASE", "SENDER",
  "MASK_SOURCE", "VERIFY", "FORWARDONLY", "RECIPIENT", "STRING", "NUMBER",
  "'\\n'", "'='", "','", "'{'", "'}'", "'<'", "'>'", "'!'", "$accept",
  "grammar", "include", "varset", "comma", "optnl", "nl", "size", "tagged",
  "bouncedelay", "bouncedelays", "opt_limit_mda", "limits_mda",
  "opt_limit_mta", "limits_mta", "opt_limit_scheduler", "limits_scheduler",
  "opt_pki", "pki", "opt_listen", "listen", "opt_relay_common",
  "opt_relay", "relay", "opt_relay_via", "relay_via", "main", "$@1", "$@2",
  "$@3", "$@4", "$@5", "$@6", "filter_args", "$@7", "table", "$@8",
  "assign", "keyval", "keyval_list", "stringel", "string_list",
  "tableval_list", "tablenew", "$@9", "tableref", "tables", "alias",
  "virtual", "usermapping", "userbase", "deliver_action", "relay_action",
  "$@10", "negation", "from", "for", "sender", "recipient", "forwardonly",
  "expire", "opt_decision", "decision", "opt_lookup", "lookup", "action",
  "opt_accept", "accept_params", "rule", "$@11", "$@12", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,    10,    61,    44,
     123,   125,    60,    62,    33
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    75,    76,    76,    76,    76,    76,    76,    76,    76,
      77,    78,    79,    79,    79,    80,    80,    81,    82,    82,
      83,    84,    85,    85,    85,    86,    87,    87,    88,    88,
      88,    89,    89,    90,    91,    91,    92,    92,    92,    92,
      93,    93,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    95,    95,    96,    96,    96,    96,    96,
      97,    97,    97,    97,    98,    98,    98,    99,    99,   100,
     100,   100,   102,   101,   101,   101,   101,   101,   101,   101,
     101,   103,   101,   104,   101,   101,   105,   101,   106,   101,
     107,   101,   108,   109,   108,   110,   111,   110,   112,   112,
     113,   114,   114,   115,   116,   116,   117,   117,   118,   119,
     118,   120,   121,   121,   122,   123,   124,   124,   125,   126,
     126,   126,   126,   126,   127,   128,   127,   129,   129,   130,
     130,   130,   131,   131,   131,   132,   133,   134,   135,   136,
     136,   136,   136,   136,   137,   137,   138,   138,   139,   139,
     140,   140,   140,   141,   141,   142,   142,   144,   143,   145,
     143
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     3,     3,     3,     3,     3,     3,
       2,     3,     1,     1,     0,     2,     0,     2,     1,     1,
       3,     1,     3,     1,     0,     2,     2,     0,     1,     1,
       2,     2,     0,     2,     2,     0,     2,     2,     2,     2,
       2,     0,     1,     1,     2,     2,     2,     1,     2,     1,
       1,     1,     2,     2,     1,     1,     2,     2,     2,     2,
       2,     1,     1,     2,     0,     2,     2,     2,     2,     2,
       2,     1,     1,     2,     2,     2,     0,     2,     1,     2,
       2,     0,     0,     3,     2,     2,     4,     2,     2,     2,
       3,     0,     7,     0,     4,     3,     0,     5,     0,     5,
       0,     4,     0,     0,     3,     3,     0,     6,     1,     1,
       3,     1,     3,     1,     1,     3,     1,     1,     1,     0,
       4,     3,     1,     1,     2,     2,     1,     1,     2,     3,
       4,     3,     4,     4,     2,     0,     5,     1,     0,     4,
       3,     3,     4,     3,     3,     3,     3,     1,     2,     1,
       1,     1,     1,     1,     2,     0,     1,     1,     2,     0,
       1,     1,     0,     1,     1,     2,     0,     0,     6,     0,
       3
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     1,     0,     0,     0,     0,    96,     0,     0,
      82,     0,   167,   169,     0,     0,     0,     0,     3,     0,
       0,     0,     0,     0,     9,    84,    85,    19,    18,    88,
      89,     0,    87,   106,    24,    27,    93,    35,   155,   155,
      10,   100,     0,     0,     4,     5,     6,     7,     8,     0,
       0,   105,     0,    21,    23,    83,     0,    27,    90,     0,
      32,     0,    35,    95,   138,   138,   138,   138,   138,   153,
     151,   152,   149,   150,   155,   159,   170,    41,    98,    11,
      86,    64,     0,     0,    25,    26,     0,    28,    29,     0,
      32,    94,    33,    34,   137,     0,     0,     0,     0,     0,
     154,     0,     0,     0,   126,   127,   157,   156,   159,   162,
       0,     0,     0,     0,    41,   101,   102,     0,    50,    47,
      42,    43,    62,     0,     0,     0,    54,    49,     0,     0,
      55,    51,    61,    64,    97,   113,    14,   117,    14,   116,
       0,    22,    91,    30,    31,   140,     0,   141,   143,     0,
     144,    20,   118,   119,     0,   122,   123,   145,   146,   125,
     124,   128,   158,    76,     0,   160,   161,   166,    36,    37,
      38,    39,    40,   103,    99,    44,    45,    48,    59,    60,
      53,    56,    58,    46,    57,    52,    63,   109,   108,     0,
      16,    12,     0,    13,     0,   107,    32,   139,   142,     0,
       0,     0,    71,     0,     0,     0,     0,     0,    72,    76,
      76,   134,     0,     0,   147,   164,   163,   166,   168,   102,
     110,    16,    17,     0,   112,   113,   115,    92,     0,   121,
      65,    70,   135,    67,    68,    66,    69,    73,    74,    75,
       0,   129,   131,     0,   148,   165,   104,    15,   120,    81,
     132,   130,   133,     0,    78,    81,    81,   136,    77,    79,
      80
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    19,    20,   192,   222,   193,    29,    69,    54,
      55,    57,    58,    90,    91,    62,    63,   114,   115,   133,
     134,   209,   210,   211,   256,   257,    21,    34,   196,    60,
      31,   116,    77,   174,   219,    22,    52,   189,   136,   137,
     138,   139,   140,   155,   199,   156,   157,   104,   105,   106,
     107,   165,   166,   249,    95,    70,    71,    72,    73,   215,
     216,    74,    75,   108,   109,   167,   217,   218,    23,    38,
      39
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -236
static const yytype_int16 yypact[] =
{
    -236,     9,  -236,   -60,    80,    28,   -51,  -236,   -39,   -16,
    -236,    87,  -236,  -236,    -6,     3,     7,    12,  -236,    10,
      24,    33,    38,    48,  -236,  -236,    74,  -236,  -236,  -236,
    -236,   110,  -236,    61,    76,    82,   108,    84,    44,    44,
    -236,  -236,    85,    86,  -236,  -236,  -236,  -236,  -236,    88,
      90,  -236,    91,  -236,  -236,    83,    92,    82,  -236,   138,
     -10,    93,    84,  -236,    94,    94,    94,    94,    94,  -236,
    -236,  -236,  -236,  -236,    44,   -19,  -236,    15,  -236,  -236,
    -236,    66,    95,    76,  -236,  -236,    97,  -236,  -236,    98,
     -10,  -236,  -236,  -236,  -236,    13,    42,   100,   -31,   -31,
    -236,   -31,   -31,   -31,  -236,  -236,  -236,  -236,   -19,    39,
     101,   102,   104,   105,    15,  -236,   106,    31,  -236,   111,
    -236,  -236,  -236,   107,   -31,   109,   -31,  -236,   112,   113,
     -31,   114,  -236,    66,  -236,   -26,    68,  -236,    71,  -236,
     115,  -236,  -236,  -236,  -236,  -236,   -31,  -236,  -236,   -31,
    -236,  -236,  -236,  -236,   116,  -236,  -236,  -236,  -236,  -236,
    -236,  -236,  -236,    32,   129,  -236,  -236,    -7,  -236,  -236,
    -236,  -236,  -236,  -236,  -236,  -236,  -236,  -236,  -236,  -236,
    -236,  -236,  -236,  -236,  -236,  -236,  -236,  -236,  -236,   117,
      96,  -236,   118,  -236,   119,  -236,   -10,  -236,  -236,    95,
     120,   122,   123,   124,   125,   -31,   -31,   126,   130,    89,
      89,  -236,    72,   131,  -236,  -236,  -236,    -7,  -236,   106,
    -236,    96,  -236,   -26,  -236,  -236,  -236,  -236,   127,  -236,
    -236,  -236,  -236,  -236,  -236,  -236,  -236,  -236,  -236,  -236,
     132,   134,  -236,   135,  -236,  -236,  -236,  -236,  -236,     5,
    -236,  -236,  -236,   -31,  -236,     5,     5,  -236,  -236,  -236,
    -236
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -236,  -236,  -236,  -236,    37,   -42,  -236,  -236,  -236,   121,
    -236,  -236,   128,  -236,   -85,  -236,   133,  -236,    99,  -236,
      47,  -235,  -236,   -92,  -236,  -122,  -236,  -236,  -236,  -236,
    -236,  -236,  -236,   -25,  -236,  -236,  -236,  -236,  -236,    11,
    -236,     8,     2,  -236,  -236,  -236,   -99,  -236,  -236,  -236,
    -236,  -236,  -236,  -236,    78,  -236,  -236,  -236,  -236,  -236,
    -236,  -236,   -38,  -236,   103,  -236,  -236,   -12,  -236,  -236,
    -236
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -115
static const yytype_int16 yytable[] =
{
     158,    76,   159,   160,   161,   144,   213,    24,   201,     2,
       3,    87,    88,     4,   255,    30,     5,     6,     7,   187,
     255,   255,     8,     9,   145,   179,    32,   181,    10,    11,
     101,   184,   110,   102,   152,   201,   100,   204,   205,   153,
     103,   154,   188,    12,    13,    14,   206,   197,   207,    33,
     198,   253,    15,   148,   146,    89,   214,   202,   203,    40,
     149,   147,    16,   163,   204,   205,   164,   254,    41,   111,
     112,   113,    42,   206,    17,   207,    18,    44,   117,   208,
      43,   118,   119,    64,    65,    25,    26,   120,   121,   122,
     150,    45,   201,    27,    28,    66,   175,   176,   123,   124,
      46,   240,   241,   242,    67,    47,   234,   235,    68,   125,
     243,   227,   126,   127,   202,    48,   128,   238,   239,   129,
      50,   204,   205,   130,   131,    35,    51,   132,    49,    36,
     206,    37,   207,   259,   260,   190,   208,   191,   190,  -111,
     191,    53,  -114,    96,    97,    98,    99,    56,    59,    61,
      78,    79,    83,    80,   258,    81,    86,   212,    84,    92,
     135,    82,   142,   221,   143,   151,   168,   169,    94,   170,
     171,   173,   178,   177,   180,   194,   185,   182,   183,   247,
     186,   200,   220,   223,   225,    85,   195,   230,   231,   232,
     233,   236,   237,   229,   246,    93,   244,   250,   248,   251,
     252,   228,   226,   224,   141,   245,     0,     0,     0,     0,
       0,   162,     0,   172
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-236)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
      99,    39,   101,   102,   103,    90,    13,    67,     3,     0,
       1,    21,    22,     4,   249,    66,     7,     8,     9,    45,
     255,   256,    13,    14,    11,   124,    65,   126,    19,    20,
      49,   130,    17,    52,    65,     3,    74,    32,    33,    70,
      59,    72,    68,    34,    35,    36,    41,   146,    43,    65,
     149,    46,    43,    11,    41,    65,    63,    25,    26,    65,
      18,    48,    53,    24,    32,    33,    27,    62,    65,    54,
      55,    56,    65,    41,    65,    43,    67,    67,    12,    47,
      68,    15,    16,    39,    40,     5,     6,    21,    22,    23,
      48,    67,     3,    65,    66,    51,    65,    66,    32,    33,
      67,    29,    30,    31,    60,    67,   205,   206,    64,    43,
      38,   196,    46,    47,    25,    67,    50,   209,   210,    53,
      10,    32,    33,    57,    58,    38,    65,    61,    54,    42,
      41,    44,    43,   255,   256,    67,    47,    69,    67,    71,
      69,    65,    71,    65,    66,    67,    68,    65,    40,    65,
      65,    65,    69,    65,   253,    65,    18,    28,    66,    66,
      65,    70,    65,    67,    66,    65,    65,    65,    74,    65,
      65,    65,    65,    62,    65,   138,    62,    65,    65,   221,
     133,    65,    65,    65,    65,    57,    71,    65,    65,    65,
      65,    65,    62,    73,   219,    62,    65,    65,    71,    65,
      65,   199,   194,   192,    83,   217,    -1,    -1,    -1,    -1,
      -1,   108,    -1,   114
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    76,     0,     1,     4,     7,     8,     9,    13,    14,
      19,    20,    34,    35,    36,    43,    53,    65,    67,    77,
      78,   101,   110,   143,    67,     5,     6,    65,    66,    82,
      66,   105,    65,    65,   102,    38,    42,    44,   144,   145,
      65,    65,    65,    68,    67,    67,    67,    67,    67,    54,
      10,    65,   111,    65,    84,    85,    65,    86,    87,    40,
     104,    65,    90,    91,    39,    40,    51,    60,    64,    83,
     130,   131,   132,   133,   136,   137,   137,   107,    65,    65,
      65,    65,    70,    69,    66,    87,    18,    21,    22,    65,
      88,    89,    66,    91,    74,   129,   129,   129,   129,   129,
     137,    49,    52,    59,   122,   123,   124,   125,   138,   139,
      17,    54,    55,    56,    92,    93,   106,    12,    15,    16,
      21,    22,    23,    32,    33,    43,    46,    47,    50,    53,
      57,    58,    61,    94,    95,    65,   113,   114,   115,   116,
     117,    84,    65,    66,    89,    11,    41,    48,    11,    18,
      48,    65,    65,    70,    72,   118,   120,   121,   121,   121,
     121,   121,   139,    24,    27,   126,   127,   140,    65,    65,
      65,    65,    93,    65,   108,    65,    66,    62,    65,   121,
      65,   121,    65,    65,   121,    62,    95,    45,    68,   112,
      67,    69,    79,    81,    79,    71,   103,   121,   121,   119,
      65,     3,    25,    26,    32,    33,    41,    43,    47,    96,
      97,    98,    28,    13,    63,   134,   135,   141,   142,   109,
      65,    67,    80,    65,   114,    65,   116,    89,   117,    73,
      65,    65,    65,    65,   121,   121,    65,    62,    98,    98,
      29,    30,    31,    38,    65,   142,   108,    80,    71,   128,
      65,    65,    65,    46,    62,    96,    99,   100,   121,   100,
     100
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 9:
/* Line 1792 of yacc.c  */
#line 191 "../../smtpd/parse.y"
    { file->errors++; }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 194 "../../smtpd/parse.y"
    {
			struct file	*nfile;

			if ((nfile = pushfile((yyvsp[(2) - (2)].v.string), 0)) == NULL) {
				yyerror("failed to include file %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));

			file = nfile;
			lungetc('\n');
		}
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 209 "../../smtpd/parse.y"
    {
			if (symset((yyvsp[(1) - (3)].v.string), (yyvsp[(3) - (3)].v.string), 0) == -1)
				fatal("cannot store variable");
			free((yyvsp[(1) - (3)].v.string));
			free((yyvsp[(3) - (3)].v.string));
		}
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 229 "../../smtpd/parse.y"
    {
			if ((yyvsp[(1) - (1)].v.number) < 0) {
				yyerror("invalid size: %" PRId64, (yyvsp[(1) - (1)].v.number));
				YYERROR;
			}
			(yyval.v.number) = (yyvsp[(1) - (1)].v.number);
		}
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 236 "../../smtpd/parse.y"
    {
			long long result;

			if (scan_scaled((yyvsp[(1) - (1)].v.string), &result) == -1 || result < 0) {
				yyerror("invalid size: %s", (yyvsp[(1) - (1)].v.string));
				free((yyvsp[(1) - (1)].v.string));
				YYERROR;
			}
			free((yyvsp[(1) - (1)].v.string));
			(yyval.v.number) = result;
		}
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 249 "../../smtpd/parse.y"
    {
			if (strlcpy(rule->r_tag, (yyvsp[(3) - (3)].v.string), sizeof rule->r_tag)
			    >= sizeof rule->r_tag) {
				yyerror("tag name too long: %s", (yyvsp[(3) - (3)].v.string));
				free((yyvsp[(3) - (3)].v.string));
				YYERROR;
			}
			free((yyvsp[(3) - (3)].v.string));
			rule->r_nottag = (yyvsp[(2) - (3)].v.number);
		}
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 261 "../../smtpd/parse.y"
    {
			time_t	d;
			int	i;

			d = delaytonum((yyvsp[(1) - (1)].v.string));
			if (d < 0) {
				yyerror("invalid bounce delay: %s", (yyvsp[(1) - (1)].v.string));
				free((yyvsp[(1) - (1)].v.string));
				YYERROR;
			}
			free((yyvsp[(1) - (1)].v.string));
			for (i = 0; i < MAX_BOUNCE_WARN; i++) {
				if (conf->sc_bounce_warn[i] != 0)
					continue;
				conf->sc_bounce_warn[i] = d;
				break;
			}
		}
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 285 "../../smtpd/parse.y"
    {
			if (!strcmp((yyvsp[(1) - (2)].v.string), "max-session")) {
				conf->sc_mda_max_session = (yyvsp[(2) - (2)].v.number);
			}
			else if (!strcmp((yyvsp[(1) - (2)].v.string), "max-session-per-user")) {
				conf->sc_mda_max_user_session = (yyvsp[(2) - (2)].v.number);
			}
			else if (!strcmp((yyvsp[(1) - (2)].v.string), "task-lowat")) {
				conf->sc_mda_task_lowat = (yyvsp[(2) - (2)].v.number);
			}
			else if (!strcmp((yyvsp[(1) - (2)].v.string), "task-hiwat")) {
				conf->sc_mda_task_hiwat = (yyvsp[(2) - (2)].v.number);
			}
			else if (!strcmp((yyvsp[(1) - (2)].v.string), "task-release")) {
				conf->sc_mda_task_release = (yyvsp[(2) - (2)].v.number);
			}
			else {
				yyerror("invalid scheduler limit keyword: %s", (yyvsp[(1) - (2)].v.string));
				free((yyvsp[(1) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(1) - (2)].v.string));
		}
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 314 "../../smtpd/parse.y"
    {
			limits->family = AF_INET;
		}
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 317 "../../smtpd/parse.y"
    {
			limits->family = AF_INET6;
		}
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 320 "../../smtpd/parse.y"
    {
			if (!limit_mta_set(limits, (yyvsp[(1) - (2)].v.string), (yyvsp[(2) - (2)].v.number))) {
				yyerror("invalid mta limit keyword: %s", (yyvsp[(1) - (2)].v.string));
				free((yyvsp[(1) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(1) - (2)].v.string));
		}
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 334 "../../smtpd/parse.y"
    {
			if (!strcmp((yyvsp[(1) - (2)].v.string), "max-inflight")) {
				conf->sc_scheduler_max_inflight = (yyvsp[(2) - (2)].v.number);
			}
			else if (!strcmp((yyvsp[(1) - (2)].v.string), "max-evp-batch-size")) {
				conf->sc_scheduler_max_evp_batch_size = (yyvsp[(2) - (2)].v.number);
			}
			else if (!strcmp((yyvsp[(1) - (2)].v.string), "max-msg-batch-size")) {
				conf->sc_scheduler_max_msg_batch_size = (yyvsp[(2) - (2)].v.number);
			}
			else if (!strcmp((yyvsp[(1) - (2)].v.string), "max-schedule")) {
				conf->sc_scheduler_max_schedule = (yyvsp[(2) - (2)].v.number);
			}
			else {
				yyerror("invalid scheduler limit keyword: %s", (yyvsp[(1) - (2)].v.string));
				free((yyvsp[(1) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(1) - (2)].v.string));
		}
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 360 "../../smtpd/parse.y"
    {
			pki->pki_cert_file = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 363 "../../smtpd/parse.y"
    {
			pki->pki_key_file = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 366 "../../smtpd/parse.y"
    {
			pki->pki_ca_file = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 369 "../../smtpd/parse.y"
    {
			pki->pki_dhparams_file = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 378 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_FAMILY) {
				yyerror("address family already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_FAMILY;
			listen_opts.family = AF_INET;
		}
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 386 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_FAMILY) {
				yyerror("address family already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_FAMILY;
			listen_opts.family = AF_INET6;
		}
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 394 "../../smtpd/parse.y"
    {
			struct servent	*servent;

			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_PORT;

			servent = getservbyname((yyvsp[(2) - (2)].v.string), "tcp");
			if (servent == NULL) {
				yyerror("invalid port: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));
			listen_opts.port = ntohs(servent->s_port);
		}
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 412 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_PORT;

			if ((yyvsp[(2) - (2)].v.number) <= 0 || (yyvsp[(2) - (2)].v.number) >= (int)USHRT_MAX) {
				yyerror("invalid port: %" PRId64, (yyvsp[(2) - (2)].v.number));
				YYERROR;
			}
			listen_opts.port = (yyvsp[(2) - (2)].v.number);
		}
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 425 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_FILTER) {
				yyerror("filter already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_FILTER;
			listen_opts.filtername = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 433 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_SMTPS;
		}
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 441 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_SMTPS|F_TLS_VERIFY;
		}
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 449 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS;
		}
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 457 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_SSL;
		}
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 465 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS|F_STARTTLS_REQUIRE;
		}
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 473 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS|F_STARTTLS_REQUIRE|F_TLS_VERIFY;
		}
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 481 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_PKI) {
				yyerror("pki already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_PKI;
			listen_opts.pki = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 489 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.auth = F_AUTH|F_AUTH_REQUIRE;
		}
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 497 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.auth = F_AUTH;
		}
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 505 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.authtable = (yyvsp[(2) - (2)].v.table);
			listen_opts.auth = F_AUTH|F_AUTH_REQUIRE;
		}
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 514 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.authtable = (yyvsp[(2) - (2)].v.table);
			listen_opts.auth = F_AUTH;
		}
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 523 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_TAG) {
				yyerror("tag already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_TAG;

       			if (strlen((yyvsp[(2) - (2)].v.string)) >= MAX_TAG_SIZE) {
       				yyerror("tag name too long");
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			listen_opts.tag = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 537 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_HOSTNAME) {
				yyerror("hostname already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_HOSTNAME;

			listen_opts.hostname = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 546 "../../smtpd/parse.y"
    {
			struct table	*t = (yyvsp[(2) - (2)].v.table);

			if (listen_opts.options & LO_HOSTNAMES) {
				yyerror("hostnames already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_HOSTNAMES;

			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_ADDRNAME)) {
				yyerror("invalid use of table \"%s\" as "
				    "HOSTNAMES parameter", t->t_name);
				YYERROR;
			}
			listen_opts.hostnametable = t;
		}
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 562 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_MASKSOURCE) {
				yyerror("mask-source already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_MASKSOURCE;
			listen_opts.flags |= F_MASK_SOURCE;
		}
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 570 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_NODSN) {
				yyerror("no-dsn already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_NODSN;
			listen_opts.flags &= ~F_EXT_DSN;
		}
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 584 "../../smtpd/parse.y"
    {
			struct mailaddr maddr, *maddrp;

			if (! text_to_mailaddr(&maddr, (yyvsp[(2) - (2)].v.string))) {
				yyerror("invalid parameter to AS: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));

			if (maddr.user[0] == '\0' && maddr.domain[0] == '\0') {
				yyerror("invalid empty parameter to AS");
				YYERROR;
			}
			else if (maddr.domain[0] == '\0') {
				if (strlcpy(maddr.domain, conf->sc_hostname,
					sizeof (maddr.domain))
				    >= sizeof (maddr.domain)) {
					yyerror("hostname too long for AS parameter: %s",
					    conf->sc_hostname);
					YYERROR;
				}
			}
			rule->r_as = xmemdup(&maddr, sizeof (*maddrp), "parse relay_as: AS");
		}
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 609 "../../smtpd/parse.y"
    {
			struct table	*t = (yyvsp[(2) - (2)].v.table);
			if (! table_check_use(t, T_DYNAMIC|T_LIST, K_SOURCE)) {
				yyerror("invalid use of table \"%s\" as "
				    "SOURCE parameter", t->t_name);
				YYERROR;
			}
			(void)strlcpy(rule->r_value.relayhost.sourcetable, t->t_name,
			    sizeof rule->r_value.relayhost.sourcetable);
		}
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 619 "../../smtpd/parse.y"
    {
			(void)strlcpy(rule->r_value.relayhost.heloname, (yyvsp[(2) - (2)].v.string),
			    sizeof rule->r_value.relayhost.heloname);
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 624 "../../smtpd/parse.y"
    {
			struct table	*t = (yyvsp[(2) - (2)].v.table);
			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_ADDRNAME)) {
				yyerror("invalid use of table \"%s\" as "
				    "HOSTNAMES parameter", t->t_name);
				YYERROR;
			}
			(void)strlcpy(rule->r_value.relayhost.helotable, t->t_name,
			    sizeof rule->r_value.relayhost.helotable);
		}
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 634 "../../smtpd/parse.y"
    {
			if (! lowercase(rule->r_value.relayhost.pki_name, (yyvsp[(2) - (2)].v.string),
				sizeof(rule->r_value.relayhost.pki_name))) {
				yyerror("pki name too long: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			if (dict_get(conf->sc_pki_dict,
			    rule->r_value.relayhost.pki_name) == NULL) {
				log_warnx("pki name not found: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 651 "../../smtpd/parse.y"
    {
			rule->r_value.relayhost.flags |= F_BACKUP;
			if (strlcpy(rule->r_value.relayhost.hostname, (yyvsp[(2) - (2)].v.string),
				sizeof (rule->r_value.relayhost.hostname))
			    >= sizeof (rule->r_value.relayhost.hostname)) {
				log_warnx("hostname too long: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 662 "../../smtpd/parse.y"
    {
			rule->r_value.relayhost.flags |= F_BACKUP;
			(void)strlcpy(rule->r_value.relayhost.hostname,
			    conf->sc_hostname,
			    sizeof (rule->r_value.relayhost.hostname));
		}
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 668 "../../smtpd/parse.y"
    {
			rule->r_value.relayhost.flags |= F_STARTTLS;
		}
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 671 "../../smtpd/parse.y"
    {
			rule->r_value.relayhost.flags |= F_STARTTLS|F_TLS_VERIFY;
		}
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 681 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(2) - (2)].v.table);

			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_CREDENTIALS)) {
				yyerror("invalid use of table \"%s\" as AUTH parameter",
				    t->t_name);
				YYERROR;
			}
			(void)strlcpy(rule->r_value.relayhost.authtable, t->t_name,
			    sizeof(rule->r_value.relayhost.authtable));
		}
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 692 "../../smtpd/parse.y"
    {
			if (!(rule->r_value.relayhost.flags & F_SSL)) {
				yyerror("cannot \"verify\" with insecure protocol");
				YYERROR;
			}
			rule->r_value.relayhost.flags |= F_TLS_VERIFY;
		}
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 706 "../../smtpd/parse.y"
    {
			memset(conf->sc_bounce_warn, 0, sizeof conf->sc_bounce_warn);
		}
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 709 "../../smtpd/parse.y"
    {
			conf->sc_queue_flags |= QUEUE_COMPRESSION;
		}
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 712 "../../smtpd/parse.y"
    {
			conf->sc_queue_flags |= QUEUE_ENCRYPTION;
		}
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 715 "../../smtpd/parse.y"
    {
			if (strcasecmp((yyvsp[(4) - (4)].v.string), "stdin") == 0 || strcasecmp((yyvsp[(4) - (4)].v.string), "-") == 0) {
				conf->sc_queue_key = "stdin";
				free((yyvsp[(4) - (4)].v.string));
			}
			else
				conf->sc_queue_key = (yyvsp[(4) - (4)].v.string);
			conf->sc_queue_flags |= QUEUE_ENCRYPTION;
		}
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 724 "../../smtpd/parse.y"
    {
			conf->sc_qexpire = delaytonum((yyvsp[(2) - (2)].v.string));
			if (conf->sc_qexpire == -1) {
				yyerror("invalid expire delay: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 733 "../../smtpd/parse.y"
    {
			conf->sc_maxsize = (yyvsp[(2) - (2)].v.number);
		}
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 736 "../../smtpd/parse.y"
    {
			conf->sc_mta_max_deferred = (yyvsp[(2) - (2)].v.number);
		}
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 740 "../../smtpd/parse.y"
    {
			struct mta_limits	*d;

			limits = dict_get(conf->sc_limits_dict, (yyvsp[(5) - (5)].v.string));
			if (limits == NULL) {
				limits = xcalloc(1, sizeof(*limits), "mta_limits");
				dict_xset(conf->sc_limits_dict, (yyvsp[(5) - (5)].v.string), limits);
				d = dict_xget(conf->sc_limits_dict, "default");
				memmove(limits, d, sizeof(*limits));
			}
			free((yyvsp[(5) - (5)].v.string));
		}
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 752 "../../smtpd/parse.y"
    {
			limits = dict_get(conf->sc_limits_dict, "default");
		}
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 756 "../../smtpd/parse.y"
    {
			memset(&l, 0, sizeof l);
			memset(&listen_opts, 0, sizeof listen_opts);
			listen_opts.family = AF_UNSPEC;
			listen_opts.flags |= F_EXT_DSN;
		}
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 761 "../../smtpd/parse.y"
    {
			listen_opts.ifx = (yyvsp[(4) - (5)].v.string);
			create_listener(conf->sc_listeners, &listen_opts);
		}
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 765 "../../smtpd/parse.y"
    {
			if (!strcmp((yyvsp[(3) - (3)].v.string), "chain")) {
				free((yyvsp[(3) - (3)].v.string));
				if ((filter = create_filter_chain((yyvsp[(2) - (3)].v.string))) == NULL) {
					free((yyvsp[(2) - (3)].v.string));
					YYERROR;
				}
			}
			else {
				if ((filter = create_filter_proc((yyvsp[(2) - (3)].v.string), (yyvsp[(3) - (3)].v.string))) == NULL) {
					free((yyvsp[(2) - (3)].v.string));
					free((yyvsp[(3) - (3)].v.string));
					YYERROR;
				}
			}
		}
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 781 "../../smtpd/parse.y"
    {
			char buf[SMTPD_MAXHOSTNAMELEN];
			xlowercase(buf, (yyvsp[(2) - (2)].v.string), sizeof(buf));
			free((yyvsp[(2) - (2)].v.string));
			pki = dict_get(conf->sc_pki_dict, buf);
			if (pki == NULL) {
				pki = xcalloc(1, sizeof *pki, "parse:pki");
				(void)strlcpy(pki->pki_name, buf, sizeof(pki->pki_name));
				dict_set(conf->sc_pki_dict, pki->pki_name, pki);
			}
		}
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 795 "../../smtpd/parse.y"
    {
			if (!add_filter_arg(filter, (yyvsp[(1) - (1)].v.string))) {
				free((yyvsp[(1) - (1)].v.string));
				YYERROR;
			}
		}
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 803 "../../smtpd/parse.y"
    {
			char *p, *backend, *config;

			p = (yyvsp[(3) - (3)].v.string);
			if (*p == '/') {
				backend = "static";
				config = (yyvsp[(3) - (3)].v.string);
			}
			else {
				backend = (yyvsp[(3) - (3)].v.string);
				config = NULL;
				for (p = (yyvsp[(3) - (3)].v.string); *p && *p != ':'; p++)
					;
				if (*p == ':') {
					*p = '\0';
					backend = (yyvsp[(3) - (3)].v.string);
					config  = p+1;
				}
			}
			if (config != NULL && *config != '/') {
				yyerror("invalid backend parameter for table: %s",
				    (yyvsp[(2) - (3)].v.string));
				free((yyvsp[(2) - (3)].v.string));
				free((yyvsp[(3) - (3)].v.string));
				YYERROR;
			}
			table = table_create(backend, (yyvsp[(2) - (3)].v.string), NULL, config);
			if (!table_config(table)) {
				yyerror("invalid configuration file %s for table %s",
				    config, table->t_name);
				free((yyvsp[(2) - (3)].v.string));
				free((yyvsp[(3) - (3)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (3)].v.string));
			free((yyvsp[(3) - (3)].v.string));
		}
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 840 "../../smtpd/parse.y"
    {
			table = table_create("static", (yyvsp[(2) - (2)].v.string), NULL, NULL);
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 843 "../../smtpd/parse.y"
    {
			table = NULL;
		}
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 850 "../../smtpd/parse.y"
    {
			table->t_type = T_HASH;
			table_add(table, (yyvsp[(1) - (3)].v.string), (yyvsp[(3) - (3)].v.string));
			free((yyvsp[(1) - (3)].v.string));
			free((yyvsp[(3) - (3)].v.string));
		}
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 862 "../../smtpd/parse.y"
    {
			table->t_type = T_LIST;
			table_add(table, (yyvsp[(1) - (1)].v.string), NULL);
			free((yyvsp[(1) - (1)].v.string));
		}
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 873 "../../smtpd/parse.y"
    { }
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 874 "../../smtpd/parse.y"
    { }
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 877 "../../smtpd/parse.y"
    {
			struct table	*t;

			t = table_create("static", NULL, NULL, NULL);
			t->t_type = T_LIST;
			table_add(t, (yyvsp[(1) - (1)].v.string), NULL);
			free((yyvsp[(1) - (1)].v.string));
			(yyval.v.table) = t;
		}
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 886 "../../smtpd/parse.y"
    {
			table = table_create("static", NULL, NULL, NULL);
		}
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 888 "../../smtpd/parse.y"
    {
			(yyval.v.table) = table;
		}
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 893 "../../smtpd/parse.y"
    {
			struct table	*t;

			if ((t = table_find((yyvsp[(2) - (3)].v.string), NULL)) == NULL) {
				yyerror("no such table: %s", (yyvsp[(2) - (3)].v.string));
				free((yyvsp[(2) - (3)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (3)].v.string));
			(yyval.v.table) = t;
		}
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 906 "../../smtpd/parse.y"
    { (yyval.v.table) = (yyvsp[(1) - (1)].v.table); }
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 907 "../../smtpd/parse.y"
    { (yyval.v.table) = (yyvsp[(1) - (1)].v.table); }
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 910 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(2) - (2)].v.table);

			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_ALIAS)) {
				yyerror("invalid use of table \"%s\" as ALIAS parameter",
				    t->t_name);
				YYERROR;
			}

			(yyval.v.table) = t;
		}
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 923 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(2) - (2)].v.table);

			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_ALIAS)) {
				yyerror("invalid use of table \"%s\" as VIRTUAL parameter",
				    t->t_name);
				YYERROR;
			}
			(yyval.v.table) = t;
		}
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 935 "../../smtpd/parse.y"
    {
			if (rule->r_mapping) {
				yyerror("alias specified multiple times");
				YYERROR;
			}
			rule->r_desttype = DEST_DOM;
			rule->r_mapping = (yyvsp[(1) - (1)].v.table);
		}
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 943 "../../smtpd/parse.y"
    {
			if (rule->r_mapping) {
				yyerror("virtual specified multiple times");
				YYERROR;
			}
			rule->r_desttype = DEST_VDOM;
			rule->r_mapping = (yyvsp[(1) - (1)].v.table);
		}
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 953 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(2) - (2)].v.table);

			if (rule->r_userbase) {
				yyerror("userbase specified multiple times");
				YYERROR;
			}
			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_USERINFO)) {
				yyerror("invalid use of table \"%s\" as USERBASE parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_userbase = t;
		}
    break;

  case 129:
/* Line 1792 of yacc.c  */
#line 969 "../../smtpd/parse.y"
    {
			rule->r_action = A_MAILDIR;
			if (strlcpy(rule->r_value.buffer, "~/Maildir",
			    sizeof(rule->r_value.buffer)) >=
			    sizeof(rule->r_value.buffer))
				fatal("pathname too long");
		}
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 976 "../../smtpd/parse.y"
    {
			rule->r_action = A_MAILDIR;
			if (strlcpy(rule->r_value.buffer, (yyvsp[(4) - (4)].v.string),
			    sizeof(rule->r_value.buffer)) >=
			    sizeof(rule->r_value.buffer))
				fatal("pathname too long");
			free((yyvsp[(4) - (4)].v.string));
		}
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 984 "../../smtpd/parse.y"
    {
			rule->r_action = A_MBOX;
			if (strlcpy(rule->r_value.buffer, _PATH_MAILDIR "/%u",
			    sizeof(rule->r_value.buffer))
			    >= sizeof(rule->r_value.buffer))
				fatal("pathname too long");
		}
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 991 "../../smtpd/parse.y"
    {
			rule->r_action = A_LMTP;
			if (strchr((yyvsp[(4) - (4)].v.string), ':') || (yyvsp[(4) - (4)].v.string)[0] == '/') {
				if (strlcpy(rule->r_value.buffer, (yyvsp[(4) - (4)].v.string),
					sizeof(rule->r_value.buffer))
					>= sizeof(rule->r_value.buffer))
					fatal("lmtp destination too long");
			} else
				fatal("invalid lmtp destination");
			free((yyvsp[(4) - (4)].v.string));
		}
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 1002 "../../smtpd/parse.y"
    {
			rule->r_action = A_MDA;
			if (strlcpy(rule->r_value.buffer, (yyvsp[(4) - (4)].v.string),
			    sizeof(rule->r_value.buffer))
			    >= sizeof(rule->r_value.buffer))
				fatal("command too long");
			free((yyvsp[(4) - (4)].v.string));
		}
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 1012 "../../smtpd/parse.y"
    {
			rule->r_action = A_RELAY;
		}
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 1015 "../../smtpd/parse.y"
    {
			rule->r_action = A_RELAYVIA;
			if (! text_to_relayhost(&rule->r_value.relayhost, (yyvsp[(3) - (3)].v.string))) {
				yyerror("error: invalid url: %s", (yyvsp[(3) - (3)].v.string));
				free((yyvsp[(3) - (3)].v.string));
				YYERROR;
			}
			free((yyvsp[(3) - (3)].v.string));
		}
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 1023 "../../smtpd/parse.y"
    {
			/* no worries, F_AUTH cant be set without SSL */
			if (rule->r_value.relayhost.flags & F_AUTH) {
				if (rule->r_value.relayhost.authtable[0] == '\0') {
					yyerror("error: auth without auth table");
					YYERROR;
				}
			}
		}
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 1034 "../../smtpd/parse.y"
    { (yyval.v.number) = 1; }
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 1035 "../../smtpd/parse.y"
    { (yyval.v.number) = 0; }
    break;

  case 139:
/* Line 1792 of yacc.c  */
#line 1038 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(4) - (4)].v.table);

			if (rule->r_sources) {
				yyerror("from specified multiple times");
				YYERROR;
			}
			if (! table_check_use(t, T_DYNAMIC|T_LIST, K_NETADDR)) {
				yyerror("invalid use of table \"%s\" as FROM parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_notsources = (yyvsp[(2) - (4)].v.number);
			rule->r_sources = t;
		}
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 1053 "../../smtpd/parse.y"
    {
			if (rule->r_sources) {
				yyerror("from specified multiple times");
				YYERROR;
			}
			rule->r_sources = table_find("<anyhost>", NULL);
			rule->r_notsources = (yyvsp[(2) - (3)].v.number);
		}
    break;

  case 141:
/* Line 1792 of yacc.c  */
#line 1061 "../../smtpd/parse.y"
    {
			if (rule->r_sources) {
				yyerror("from specified multiple times");
				YYERROR;
			}
			rule->r_sources = table_find("<localhost>", NULL);
			rule->r_notsources = (yyvsp[(2) - (3)].v.number);
		}
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 1071 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(4) - (4)].v.table);

			if (rule->r_destination) {
				yyerror("for specified multiple times");
				YYERROR;
			}
			if (! table_check_use(t, T_DYNAMIC|T_LIST, K_DOMAIN)) {
				yyerror("invalid use of table \"%s\" as DOMAIN parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_notdestination = (yyvsp[(2) - (4)].v.number);
			rule->r_destination = t;
		}
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 1086 "../../smtpd/parse.y"
    {
			if (rule->r_destination) {
				yyerror("for specified multiple times");
				YYERROR;
			}
			rule->r_notdestination = (yyvsp[(2) - (3)].v.number);
			rule->r_destination = table_find("<anydestination>", NULL);
		}
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 1094 "../../smtpd/parse.y"
    {
			if (rule->r_destination) {
				yyerror("for specified multiple times");
				YYERROR;
			}
			rule->r_notdestination = (yyvsp[(2) - (3)].v.number);
			rule->r_destination = table_find("<localnames>", NULL);
		}
    break;

  case 145:
/* Line 1792 of yacc.c  */
#line 1104 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(3) - (3)].v.table);

			if (rule->r_senders) {
				yyerror("sender specified multiple times");
				YYERROR;
			}

			if (! table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
				yyerror("invalid use of table \"%s\" as SENDER parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_notsenders = (yyvsp[(2) - (3)].v.number);
			rule->r_senders = t;
		}
    break;

  case 146:
/* Line 1792 of yacc.c  */
#line 1122 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(3) - (3)].v.table);

			if (rule->r_recipients) {
				yyerror("recipient specified multiple times");
				YYERROR;
			}

			if (! table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
				yyerror("invalid use of table \"%s\" as RECIPIENT parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_notrecipients = (yyvsp[(2) - (3)].v.number);
			rule->r_recipients = t;
		}
    break;

  case 147:
/* Line 1792 of yacc.c  */
#line 1140 "../../smtpd/parse.y"
    {
			if (rule->r_forwardonly) {
				yyerror("forward-only specified multiple times");
				YYERROR;
			}
			rule->r_forwardonly = 1;
		}
    break;

  case 148:
/* Line 1792 of yacc.c  */
#line 1149 "../../smtpd/parse.y"
    {
			if (rule->r_qexpire != -1) {
				yyerror("expire specified multiple times");
				YYERROR;
			}
			rule->r_qexpire = delaytonum((yyvsp[(2) - (2)].v.string));
			if (rule->r_qexpire == -1) {
				yyerror("invalid expire delay: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 167:
/* Line 1792 of yacc.c  */
#line 1194 "../../smtpd/parse.y"
    {
			rule = xcalloc(1, sizeof(*rule), "parse rule: ACCEPT");
			rule->r_action = A_NONE;
			rule->r_decision = R_ACCEPT;
			rule->r_desttype = DEST_DOM;
			rule->r_qexpire = -1;
		}
    break;

  case 168:
/* Line 1792 of yacc.c  */
#line 1200 "../../smtpd/parse.y"
    {
			if (! rule->r_sources)
				rule->r_sources = table_find("<localhost>", NULL);			
			if (! rule->r_destination)
			 	rule->r_destination = table_find("<localnames>", NULL);
			if (! rule->r_userbase)
				rule->r_userbase = table_find("<getpwnam>", NULL);
			if (rule->r_qexpire == -1)
				rule->r_qexpire = conf->sc_qexpire;
			if (rule->r_action == A_RELAY || rule->r_action == A_RELAYVIA) {
				if (rule->r_userbase != table_find("<getpwnam>", NULL)) {
					yyerror("userbase may not be used with a relay rule");
					YYERROR;
				}
				if (rule->r_mapping) {
					yyerror("aliases/virtual may not be used with a relay rule");
					YYERROR;
				}
			}
			if (rule->r_forwardonly && rule->r_action != A_NONE) {
				yyerror("forward-only may not be used with a default action");
				YYERROR;
			}
			TAILQ_INSERT_TAIL(conf->sc_rules, rule, r_entry);
			rule = NULL;
		}
    break;

  case 169:
/* Line 1792 of yacc.c  */
#line 1226 "../../smtpd/parse.y"
    {
			rule = xcalloc(1, sizeof(*rule), "parse rule: REJECT");
			rule->r_decision = R_REJECT;
			rule->r_desttype = DEST_DOM;
		}
    break;

  case 170:
/* Line 1792 of yacc.c  */
#line 1230 "../../smtpd/parse.y"
    {
			if (! rule->r_sources)
				rule->r_sources = table_find("<localhost>", NULL);
			if (! rule->r_destination)
				rule->r_destination = table_find("<localnames>", NULL);
			TAILQ_INSERT_TAIL(conf->sc_rules, rule, r_entry);
			rule = NULL;
		}
    break;


/* Line 1792 of yacc.c  */
#line 3279 "parse.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 1239 "../../smtpd/parse.y"


struct keywords {
	const char	*k_name;
	int		 k_val;
};

int
yyerror(const char *fmt, ...)
{
	va_list		 ap;
	char		*msg;

	file->errors++;
	va_start(ap, fmt);
	if (vasprintf(&msg, fmt, ap) == -1)
		fatalx("yyerror vasprintf");
	va_end(ap);
	logit(LOG_CRIT, "%s:%d: %s", file->name, yylval.lineno, msg);
	free(msg);
	return (0);
}

int
kw_cmp(const void *k, const void *e)
{
	return (strcmp(k, ((const struct keywords *)e)->k_name));
}

int
lookup(char *s)
{
	/* this has to be sorted always */
	static const struct keywords keywords[] = {
		{ "accept",		ACCEPT },
		{ "alias",		ALIAS },
		{ "any",		ANY },
		{ "as",			AS },
		{ "auth",		AUTH },
		{ "auth-optional",     	AUTH_OPTIONAL },
		{ "backup",		BACKUP },
		{ "bounce-warn",	BOUNCEWARN },
		{ "ca",			CA },
		{ "certificate",	CERTIFICATE },
		{ "compression",	COMPRESSION },
		{ "deliver",		DELIVER },
		{ "dhparams",		DHPARAMS },
		{ "domain",		DOMAIN },
		{ "encryption",		ENCRYPTION },
		{ "expire",		EXPIRE },
		{ "filter",		FILTER },
		{ "for",		FOR },
		{ "forward-only",      	FORWARDONLY },
		{ "from",		FROM },
		{ "hostname",		HOSTNAME },
		{ "hostnames",		HOSTNAMES },
		{ "include",		INCLUDE },
		{ "inet4",		INET4 },
		{ "inet6",		INET6 },
		{ "key",		KEY },
		{ "limit",		LIMIT },
		{ "listen",		LISTEN },
		{ "lmtp",		LMTP },
		{ "local",		LOCAL },
		{ "maildir",		MAILDIR },
		{ "mask-source",	MASK_SOURCE },
		{ "max-message-size",  	MAXMESSAGESIZE },
		{ "max-mta-deferred",  	MAXMTADEFERRED },
		{ "mbox",		MBOX },
		{ "mda",		MDA },
		{ "mta",		MTA },
		{ "no-dsn",		NODSN },
		{ "on",			ON },
		{ "pki",		PKI },
		{ "port",		PORT },
		{ "queue",		QUEUE },
		{ "recipient",		RECIPIENT },
		{ "reject",		REJECT },
		{ "relay",		RELAY },
		{ "scheduler",		SCHEDULER },
		{ "secure",		SECURE },
		{ "sender",    		SENDER },
		{ "smtps",		SMTPS },
		{ "source",		SOURCE },
		{ "table",		TABLE },
		{ "tag",		TAG },
		{ "tagged",		TAGGED },
		{ "tls",		TLS },
		{ "tls-require",       	TLS_REQUIRE },
		{ "to",			TO },
		{ "userbase",		USERBASE },
		{ "verify",		VERIFY },
		{ "via",		VIA },
		{ "virtual",		VIRTUAL },
	};
	const struct keywords	*p;

	p = bsearch(s, keywords, sizeof(keywords)/sizeof(keywords[0]),
	    sizeof(keywords[0]), kw_cmp);

	if (p)
		return (p->k_val);
	else
		return (STRING);
}

#define MAXPUSHBACK	128

u_char	*parsebuf;
int	 parseindex;
u_char	 pushback_buffer[MAXPUSHBACK];
int	 pushback_index = 0;

int
lgetc(int quotec)
{
	int		c, next;

	if (parsebuf) {
		/* Read character from the parsebuffer instead of input. */
		if (parseindex >= 0) {
			c = parsebuf[parseindex++];
			if (c != '\0')
				return (c);
			parsebuf = NULL;
		} else
			parseindex++;
	}

	if (pushback_index)
		return (pushback_buffer[--pushback_index]);

	if (quotec) {
		if ((c = getc(file->stream)) == EOF) {
			yyerror("reached end of file while parsing "
			    "quoted string");
			if (file == topfile || popfile() == EOF)
				return (EOF);
			return (quotec);
		}
		return (c);
	}

	while ((c = getc(file->stream)) == '\\') {
		next = getc(file->stream);
		if (next != '\n') {
			c = next;
			break;
		}
		yylval.lineno = file->lineno;
		file->lineno++;
	}

	while (c == EOF) {
		if (file == topfile || popfile() == EOF)
			return (EOF);
		c = getc(file->stream);
	}
	return (c);
}

int
lungetc(int c)
{
	if (c == EOF)
		return (EOF);
	if (parsebuf) {
		parseindex--;
		if (parseindex >= 0)
			return (c);
	}
	if (pushback_index < MAXPUSHBACK-1)
		return (pushback_buffer[pushback_index++] = c);
	else
		return (EOF);
}

int
findeol(void)
{
	int	c;

	parsebuf = NULL;
	pushback_index = 0;

	/* skip to either EOF or the first real EOL */
	while (1) {
		c = lgetc(0);
		if (c == '\n') {
			file->lineno++;
			break;
		}
		if (c == EOF)
			break;
	}
	return (ERROR);
}

int
yylex(void)
{
	u_char	 buf[8096];
	u_char	*p, *val;
	int	 quotec, next, c;
	int	 token;

top:
	p = buf;
	while ((c = lgetc(0)) == ' ' || c == '\t')
		; /* nothing */

	yylval.lineno = file->lineno;
	if (c == '#')
		while ((c = lgetc(0)) != '\n' && c != EOF)
			; /* nothing */
	if (c == '$' && parsebuf == NULL) {
		while (1) {
			if ((c = lgetc(0)) == EOF)
				return (0);

			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			if (isalnum(c) || c == '_') {
				*p++ = c;
				continue;
			}
			*p = '\0';
			lungetc(c);
			break;
		}
		val = symget(buf);
		if (val == NULL) {
			yyerror("macro '%s' not defined", buf);
			return (findeol());
		}
		parsebuf = val;
		parseindex = 0;
		goto top;
	}

	switch (c) {
	case '\'':
	case '"':
		quotec = c;
		while (1) {
			if ((c = lgetc(quotec)) == EOF)
				return (0);
			if (c == '\n') {
				file->lineno++;
				continue;
			} else if (c == '\\') {
				if ((next = lgetc(quotec)) == EOF)
					return (0);
				if (next == quotec || c == ' ' || c == '\t')
					c = next;
				else if (next == '\n') {
					file->lineno++;
					continue;
				} else
					lungetc(next);
			} else if (c == quotec) {
				*p = '\0';
				break;
			} else if (c == '\0') {
				yyerror("syntax error");
				return (findeol());
			}
			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			*p++ = c;
		}
		yylval.v.string = strdup(buf);
		if (yylval.v.string == NULL)
			err(1, "yylex: strdup");
		return (STRING);
	}

#define allowed_to_end_number(x) \
	(isspace(x) || x == ')' || x ==',' || x == '/' || x == '}' || x == '=')

	if (c == '-' || isdigit(c)) {
		do {
			*p++ = c;
			if ((unsigned)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && isdigit(c));
		lungetc(c);
		if (p == buf + 1 && buf[0] == '-')
			goto nodigits;
		if (c == EOF || allowed_to_end_number(c)) {
			const char *errstr = NULL;

			*p = '\0';
			yylval.v.number = strtonum(buf, LLONG_MIN,
			    LLONG_MAX, &errstr);
			if (errstr) {
				yyerror("\"%s\" invalid number: %s",
				    buf, errstr);
				return (findeol());
			}
			return (NUMBER);
		} else {
nodigits:
			while (p > buf + 1)
				lungetc(*--p);
			c = *--p;
			if (c == '-')
				return (c);
		}
	}

	if (c == '=') {
		if ((c = lgetc(0)) != EOF && c == '>')
			return (ARROW);
		lungetc(c);
		c = '=';
	}

#define allowed_in_string(x) \
	(isalnum(x) || (ispunct(x) && x != '(' && x != ')' && \
	x != '{' && x != '}' && x != '<' && x != '>' && \
	x != '!' && x != '=' && x != '#' && \
	x != ','))

	if (isalnum(c) || c == ':' || c == '_') {
		do {
			*p++ = c;
			if ((unsigned)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && (allowed_in_string(c)));
		lungetc(c);
		*p = '\0';
		if ((token = lookup(buf)) == STRING)
			if ((yylval.v.string = strdup(buf)) == NULL)
				err(1, "yylex: strdup");
		return (token);
	}
	if (c == '\n') {
		yylval.lineno = file->lineno;
		file->lineno++;
	}
	if (c == EOF)
		return (0);
	return (c);
}

int
check_file_secrecy(int fd, const char *fname)
{
	struct stat	st;

	if (fstat(fd, &st)) {
		log_warn("warn: cannot stat %s", fname);
		return (-1);
	}
	if (st.st_uid != 0 && st.st_uid != getuid()) {
		log_warnx("warn: %s: owner not root or current user", fname);
		return (-1);
	}
	if (st.st_mode & (S_IWGRP | S_IXGRP | S_IRWXO)) {
		log_warnx("warn: %s: group/world readable/writeable", fname);
		return (-1);
	}
	return (0);
}

struct file *
pushfile(const char *name, int secret)
{
	struct file	*nfile;

	if ((nfile = calloc(1, sizeof(struct file))) == NULL) {
		log_warn("warn: malloc");
		return (NULL);
	}
	if ((nfile->name = strdup(name)) == NULL) {
		log_warn("warn: malloc");
		free(nfile);
		return (NULL);
	}
	if ((nfile->stream = fopen(nfile->name, "r")) == NULL) {
		log_warn("warn: %s", nfile->name);
		free(nfile->name);
		free(nfile);
		return (NULL);
	} else if (secret &&
	    check_file_secrecy(fileno(nfile->stream), nfile->name)) {
		fclose(nfile->stream);
		free(nfile->name);
		free(nfile);
		return (NULL);
	}
	nfile->lineno = 1;
	TAILQ_INSERT_TAIL(&files, nfile, entry);
	return (nfile);
}

int
popfile(void)
{
	struct file	*prev;

	if ((prev = TAILQ_PREV(file, files, entry)) != NULL)
		prev->errors += file->errors;

	TAILQ_REMOVE(&files, file, entry);
	fclose(file->stream);
	free(file->name);
	free(file);
	file = prev;
	return (file ? 0 : EOF);
}

int
parse_config(struct smtpd *x_conf, const char *filename, int opts)
{
	struct sym     *sym, *next;
	struct table   *t;
	char		hostname[SMTPD_MAXHOSTNAMELEN];
	char		hostname_copy[SMTPD_MAXHOSTNAMELEN];

	if (! getmailname(hostname, sizeof hostname))
		return (-1);

	conf = x_conf;
	memset(conf, 0, sizeof(*conf));

	(void)strlcpy(conf->sc_hostname, hostname, sizeof(conf->sc_hostname));

	conf->sc_maxsize = DEFAULT_MAX_BODY_SIZE;

	conf->sc_tables_dict = calloc(1, sizeof(*conf->sc_tables_dict));
	conf->sc_rules = calloc(1, sizeof(*conf->sc_rules));
	conf->sc_listeners = calloc(1, sizeof(*conf->sc_listeners));
	conf->sc_pki_dict = calloc(1, sizeof(*conf->sc_pki_dict));
	conf->sc_ssl_dict = calloc(1, sizeof(*conf->sc_ssl_dict));
	conf->sc_limits_dict = calloc(1, sizeof(*conf->sc_limits_dict));

	/* Report mails delayed for more than 4 hours */
	conf->sc_bounce_warn[0] = 3600 * 4;

	if (conf->sc_tables_dict == NULL	||
	    conf->sc_rules == NULL		||
	    conf->sc_listeners == NULL		||
	    conf->sc_pki_dict == NULL		||
	    conf->sc_limits_dict == NULL) {
		log_warn("warn: cannot allocate memory");
		free(conf->sc_tables_dict);
		free(conf->sc_rules);
		free(conf->sc_listeners);
		free(conf->sc_pki_dict);
		free(conf->sc_ssl_dict);
		free(conf->sc_limits_dict);
		return (-1);
	}

	errors = 0;

	table = NULL;
	rule = NULL;

	dict_init(&conf->sc_filters);

	dict_init(conf->sc_pki_dict);
	dict_init(conf->sc_ssl_dict);
	dict_init(conf->sc_tables_dict);

	dict_init(conf->sc_limits_dict);
	limits = xcalloc(1, sizeof(*limits), "mta_limits");
	limit_mta_set_defaults(limits);
	dict_xset(conf->sc_limits_dict, "default", limits);

	TAILQ_INIT(conf->sc_listeners);
	TAILQ_INIT(conf->sc_rules);

	conf->sc_qexpire = SMTPD_QUEUE_EXPIRY;
	conf->sc_opts = opts;

	conf->sc_mta_max_deferred = 100;
	conf->sc_scheduler_max_inflight = 5000;
	conf->sc_scheduler_max_schedule = 10;
	conf->sc_scheduler_max_evp_batch_size = 256;
	conf->sc_scheduler_max_msg_batch_size = 1024;

	conf->sc_mda_max_session = 50;
	conf->sc_mda_max_user_session = 7;
	conf->sc_mda_task_hiwat = 50;
	conf->sc_mda_task_lowat = 30;
	conf->sc_mda_task_release = 10;

	if ((file = pushfile(filename, 0)) == NULL) {
		purge_config(PURGE_EVERYTHING);
		return (-1);
	}
	topfile = file;

	/*
	 * declare special "localhost", "anyhost" and "localnames" tables
	 */
	set_local(hostname);

	t = table_create("static", "<anydestination>", NULL, NULL);
	t->t_type = T_LIST;
	table_add(t, "*", NULL);

	/* can't truncate here */
	(void)strlcpy(hostname_copy, hostname, sizeof hostname_copy);

	hostname_copy[strcspn(hostname_copy, ".")] = '\0';
	if (strcmp(hostname, hostname_copy) != 0)
		table_add(t, hostname_copy, NULL);

	table_create("getpwnam", "<getpwnam>", NULL, NULL);

	/*
	 * parse configuration
	 */
	setservent(1);
	yyparse();
	errors = file->errors;
	popfile();
	endservent();

	/* Free macros and check which have not been used. */
	for (sym = TAILQ_FIRST(&symhead); sym != NULL; sym = next) {
		next = TAILQ_NEXT(sym, entry);
		if ((conf->sc_opts & SMTPD_OPT_VERBOSE) && !sym->used)
			fprintf(stderr, "warning: macro '%s' not "
			    "used\n", sym->nam);
		if (!sym->persist) {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}

	if (TAILQ_EMPTY(conf->sc_rules)) {
		log_warnx("warn: no rules, nothing to do");
		errors++;
	}

	if (errors) {
		purge_config(PURGE_EVERYTHING);
		return (-1);
	}

	return (0);
}

int
symset(const char *nam, const char *val, int persist)
{
	struct sym	*sym;

	for (sym = TAILQ_FIRST(&symhead); sym && strcmp(nam, sym->nam);
	    sym = TAILQ_NEXT(sym, entry))
		;	/* nothing */

	if (sym != NULL) {
		if (sym->persist == 1)
			return (0);
		else {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}
	if ((sym = calloc(1, sizeof(*sym))) == NULL)
		return (-1);

	sym->nam = strdup(nam);
	if (sym->nam == NULL) {
		free(sym);
		return (-1);
	}
	sym->val = strdup(val);
	if (sym->val == NULL) {
		free(sym->nam);
		free(sym);
		return (-1);
	}
	sym->used = 0;
	sym->persist = persist;
	TAILQ_INSERT_TAIL(&symhead, sym, entry);
	return (0);
}

int
cmdline_symset(char *s)
{
	char	*sym, *val;
	int	ret;
	size_t	len;

	if ((val = strrchr(s, '=')) == NULL)
		return (-1);

	len = strlen(s) - strlen(val) + 1;
	if ((sym = malloc(len)) == NULL)
		errx(1, "cmdline_symset: malloc");

	(void)strlcpy(sym, s, len);

	ret = symset(sym, val + 1, 1);
	free(sym);

	return (ret);
}

char *
symget(const char *nam)
{
	struct sym	*sym;

	TAILQ_FOREACH(sym, &symhead, entry)
		if (strcmp(nam, sym->nam) == 0) {
			sym->used = 1;
			return (sym->val);
		}
	return (NULL);
}

static void
create_listener(struct listenerlist *ll,  struct listen_opts *lo)
{
	uint16_t	flags;

	if (lo->port != 0 && lo->ssl == F_SSL)
		errx(1, "invalid listen option: tls/smtps on same port");
	
	if (lo->auth != 0 && !lo->ssl)
		errx(1, "invalid listen option: auth requires tls/smtps");
	
	if (lo->pki && !lo->ssl)
		errx(1, "invalid listen option: pki requires tls/smtps");
	
	flags = lo->flags;

	if (lo->port) {
		lo->flags = lo->ssl|lo->auth|flags;
		lo->port = htons(lo->port);
		if (! interface(ll, lo))
			if (host(ll, lo) <= 0)
				errx(1, "invalid virtual ip or interface: %s", lo->ifx);
	}
	else {
		if (lo->ssl & F_SMTPS) {
			lo->port = htons(465);
			lo->flags = F_SMTPS|lo->auth|flags;
			if (! interface(ll, lo))
				if (host(ll, lo) <= 0)
					errx(1, "invalid virtual ip or interface: %s", lo->ifx);
		}

		if (! lo->ssl || (lo->ssl & F_STARTTLS)) {
			lo->port = htons(25);
			lo->flags = lo->auth|flags;
			if (lo->ssl & F_STARTTLS)
				lo->flags |= F_STARTTLS;
			if (! interface(ll, lo))
				if (host(ll, lo) <= 0)
					errx(1, "invalid virtual ip or interface: %s", lo->ifx);
		}
	}
}

static void
config_listener(struct listener *h,  struct listen_opts *lo)
{
	h->fd = -1;
	h->port = lo->port;
	h->flags = lo->flags;

	if (lo->hostname == NULL)
		lo->hostname = conf->sc_hostname;

	if (lo->filtername) {
		if (dict_get(&conf->sc_filters, lo->filtername) == NULL) {
			log_warnx("undefined filter: %s", lo->filtername);
			fatalx(NULL);
		}
		(void)strlcpy(h->filter, lo->filtername, sizeof(h->filter));
	}

	h->pki_name[0] = '\0';

	if (lo->authtable != NULL)
		(void)strlcpy(h->authtable, lo->authtable->t_name, sizeof(h->authtable));
	if (lo->pki != NULL) {
		if (! lowercase(h->pki_name, lo->pki, sizeof(h->pki_name))) {
			log_warnx("pki name too long: %s", lo->pki);
			fatalx(NULL);
		}
		if (dict_get(conf->sc_pki_dict, h->pki_name) == NULL) {
			log_warnx("pki name not found: %s", lo->pki);
			fatalx(NULL);
		}
	}
	if (lo->tag != NULL)
		(void)strlcpy(h->tag, lo->tag, sizeof(h->tag));

	(void)strlcpy(h->hostname, lo->hostname, sizeof(h->hostname));
	if (lo->hostnametable)
		(void)strlcpy(h->hostnametable, lo->hostnametable->t_name, sizeof(h->hostnametable));

	if (lo->ssl & F_TLS_VERIFY)
		h->flags |= F_TLS_VERIFY;
}

struct listener *
host_v4(const char *s, in_port_t port)
{
	struct in_addr		 ina;
	struct sockaddr_in	*sain;
	struct listener		*h;

	memset(&ina, 0, sizeof(ina));
	if (inet_pton(AF_INET, s, &ina) != 1)
		return (NULL);

	h = xcalloc(1, sizeof(*h), "host_v4");
	sain = (struct sockaddr_in *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
	sain->sin_len = sizeof(struct sockaddr_in);
#endif
	sain->sin_family = AF_INET;
	sain->sin_addr.s_addr = ina.s_addr;
	sain->sin_port = port;

	return (h);
}

struct listener *
host_v6(const char *s, in_port_t port)
{
	struct in6_addr		 ina6;
	struct sockaddr_in6	*sin6;
	struct listener		*h;

	memset(&ina6, 0, sizeof(ina6));
	if (inet_pton(AF_INET6, s, &ina6) != 1)
		return (NULL);

	h = xcalloc(1, sizeof(*h), "host_v6");
	sin6 = (struct sockaddr_in6 *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
	sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
	sin6->sin6_family = AF_INET6;
	sin6->sin6_port = port;
	memcpy(&sin6->sin6_addr, &ina6, sizeof(ina6));

	return (h);
}

int
host_dns(struct listenerlist *al, struct listen_opts *lo)
{
	struct addrinfo		 hints, *res0, *res;
	int			 error, cnt = 0;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct listener		*h;

	memset(&hints, 0, sizeof(hints));
	hints.ai_family = PF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;
	error = getaddrinfo(lo->ifx, NULL, &hints, &res0);
	if (error == EAI_AGAIN || error == EAI_NODATA || error == EAI_NONAME)
		return (0);
	if (error) {
		log_warnx("warn: host_dns: could not parse \"%s\": %s", lo->ifx,
		    gai_strerror(error));
		return (-1);
	}

	for (res = res0; res; res = res->ai_next) {
		if (res->ai_family != AF_INET &&
		    res->ai_family != AF_INET6)
			continue;
		h = xcalloc(1, sizeof(*h), "host_dns");

		h->ss.ss_family = res->ai_family;
		if (res->ai_family == AF_INET) {
			sain = (struct sockaddr_in *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			sain->sin_addr.s_addr = ((struct sockaddr_in *)
			    res->ai_addr)->sin_addr.s_addr;
			sain->sin_port = lo->port;
		} else {
			sin6 = (struct sockaddr_in6 *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			memcpy(&sin6->sin6_addr, &((struct sockaddr_in6 *)
			    res->ai_addr)->sin6_addr, sizeof(struct in6_addr));
			sin6->sin6_port = lo->port;
		}

		config_listener(h, lo);

		TAILQ_INSERT_HEAD(al, h, entry);
		cnt++;
	}

	freeaddrinfo(res0);
	return (cnt);
}

int
host(struct listenerlist *al, struct listen_opts *lo)
{
	struct listener *h;

	h = host_v4(lo->ifx, lo->port);

	/* IPv6 address? */
	if (h == NULL)
		h = host_v6(lo->ifx, lo->port);

	if (h != NULL) {
		config_listener(h, lo);
		TAILQ_INSERT_HEAD(al, h, entry);
		return (1);
	}

	return (host_dns(al, lo));
}

int
interface(struct listenerlist *al, struct listen_opts *lo)
{
	struct ifaddrs *ifap, *p;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct listener		*h;
	int			ret = 0;

	if (getifaddrs(&ifap) == -1)
		fatal("getifaddrs");

	for (p = ifap; p != NULL; p = p->ifa_next) {
		if (p->ifa_addr == NULL)
			continue;
		if (strcmp(p->ifa_name, lo->ifx) != 0 &&
		    ! is_if_in_group(p->ifa_name, lo->ifx))
			continue;
		if (lo->family != AF_UNSPEC && lo->family != p->ifa_addr->sa_family)
			continue;

		h = xcalloc(1, sizeof(*h), "interface");

		switch (p->ifa_addr->sa_family) {
		case AF_INET:
			sain = (struct sockaddr_in *)&h->ss;
			*sain = *(struct sockaddr_in *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			sain->sin_port = lo->port;
			break;

		case AF_INET6:
			sin6 = (struct sockaddr_in6 *)&h->ss;
			*sin6 = *(struct sockaddr_in6 *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			sin6->sin6_port = lo->port;
			break;

		default:
			free(h);
			continue;
		}

		config_listener(h, lo);
		ret = 1;
		TAILQ_INSERT_HEAD(al, h, entry);
	}

	freeifaddrs(ifap);

	return ret;
}

void
set_local(const char *hostname)
{
	struct table	*t;

	t = table_create("static", "<localnames>", NULL, NULL);
	t->t_type = T_LIST;
	table_add(t, "localhost", NULL);
	table_add(t, hostname, NULL);

	set_localaddrs(t);
}

void
set_localaddrs(struct table *localnames)
{
	struct ifaddrs *ifap, *p;
	struct sockaddr_storage ss;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct table		*t;
	char buf[NI_MAXHOST + 5];

	t = table_create("static", "<anyhost>", NULL, NULL);
	table_add(t, "local", NULL);
	table_add(t, "0.0.0.0/0", NULL);
	table_add(t, "::/0", NULL);

	if (getifaddrs(&ifap) == -1)
		fatal("getifaddrs");

	t = table_create("static", "<localhost>", NULL, NULL);
	table_add(t, "local", NULL);

	for (p = ifap; p != NULL; p = p->ifa_next) {
		if (p->ifa_addr == NULL)
			continue;
		switch (p->ifa_addr->sa_family) {
		case AF_INET:
			sain = (struct sockaddr_in *)&ss;
			*sain = *(struct sockaddr_in *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			table_add(t, ss_to_text(&ss), NULL);
			table_add(localnames, ss_to_text(&ss), NULL);
			(void)snprintf(buf, sizeof buf, "[%s]", ss_to_text(&ss));
			table_add(localnames, buf, NULL);
			break;

		case AF_INET6:
			sin6 = (struct sockaddr_in6 *)&ss;
			*sin6 = *(struct sockaddr_in6 *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			table_add(t, ss_to_text(&ss), NULL);
			table_add(localnames, ss_to_text(&ss), NULL);
			(void)snprintf(buf, sizeof buf, "[%s]", ss_to_text(&ss));
			table_add(localnames, buf, NULL);
			(void)snprintf(buf, sizeof buf, "[ipv6:%s]", ss_to_text(&ss));
			table_add(localnames, buf, NULL);
			break;
		}
	}

	freeifaddrs(ifap);
}

int
delaytonum(char *str)
{
	unsigned int     factor;
	size_t           len;
	const char      *errstr = NULL;
	int              delay;
  	
	/* we need at least 1 digit and 1 unit */
	len = strlen(str);
	if (len < 2)
		goto bad;
	
	switch(str[len - 1]) {
		
	case 's':
		factor = 1;
		break;
		
	case 'm':
		factor = 60;
		break;
		
	case 'h':
		factor = 60 * 60;
		break;
		
	case 'd':
		factor = 24 * 60 * 60;
		break;
		
	default:
		goto bad;
	}
  	
	str[len - 1] = '\0';
	delay = strtonum(str, 1, INT_MAX / factor, &errstr);
	if (errstr)
		goto bad;
	
	return (delay * factor);
  	
bad:
	return (-1);
}

int
is_if_in_group(const char *ifname, const char *groupname)
{
#ifdef HAVE_STRUCT_IFGROUPREQ
        unsigned int		 len;
        struct ifgroupreq        ifgr;
        struct ifg_req          *ifg;
	int			 s;
	int			 ret = 0;

	if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
		err(1, "socket");

        memset(&ifgr, 0, sizeof(ifgr));
        if (strlcpy(ifgr.ifgr_name, ifname, IFNAMSIZ) >= IFNAMSIZ)
		errx(1, "interface name too large");

        if (ioctl(s, SIOCGIFGROUP, (caddr_t)&ifgr) == -1) {
                if (errno == EINVAL || errno == ENOTTY)
			goto end;
		err(1, "SIOCGIFGROUP");
        }

        len = ifgr.ifgr_len;
        ifgr.ifgr_groups =
            (struct ifg_req *)xcalloc(len/sizeof(struct ifg_req),
		sizeof(struct ifg_req), "is_if_in_group");
        if (ioctl(s, SIOCGIFGROUP, (caddr_t)&ifgr) == -1)
                err(1, "SIOCGIFGROUP");
	
        ifg = ifgr.ifgr_groups;
        for (; ifg && len >= sizeof(struct ifg_req); ifg++) {
                len -= sizeof(struct ifg_req);
		if (strcmp(ifg->ifgrq_group, groupname) == 0) {
			ret = 1;
			break;
		}
        }
        free(ifgr.ifgr_groups);

end:
	close(s);
	return ret;
#else
	return (0);
#endif
}

static struct filter_conf *
create_filter_proc(char *name, char *prog)
{
	struct filter_conf	*f;
	char			*path;

	if (dict_get(&conf->sc_filters, name)) {
		yyerror("filter \"%s\" already defined", name);
		return (NULL);
	}

	if (asprintf(&path, "%s/filter-%s", PATH_LIBEXEC, prog) == -1) {
		yyerror("filter \"%s\" asprintf failed", name);
		return (0);
	}

	f = xcalloc(1, sizeof(*f), "create_filter");
	f->path = path;
	f->name = name;
	f->argv[f->argc++] = name;

	dict_xset(&conf->sc_filters, name, f);

	return (f);
}

static struct filter_conf *
create_filter_chain(char *name)
{
	struct filter_conf	*f;

	if (dict_get(&conf->sc_filters, name)) {
		yyerror("filter \"%s\" already defined", name);
		return (NULL);
	}

	f = xcalloc(1, sizeof(*f), "create_filter_chain");
	f->chain = 1;
	f->name = name;

	dict_xset(&conf->sc_filters, name, f);

	return (f);
}

static int
add_filter_arg(struct filter_conf *f, char *arg)
{
	if (f->argc == MAX_FILTER_ARGS) {
		yyerror("filter \"%s\" is full", f->name);
		return (0);
	}

	if (f->chain) {
		if (dict_get(&conf->sc_filters, arg) == NULL) {
			yyerror("undefined filter \"%s\"", arg);
			return (0);
		}
		if (dict_get(&conf->sc_filters, arg) == f) {
			yyerror("filter chain cannot contain itself");
			return (0);
		}
	}

	f->argv[f->argc++] = arg;

	return (1);
}
